<!DOCTYPE html>
<html lang="cs">
  <head>
    <meta charset='UTF-8'>
    <meta name="author" content="Benjamin Verner">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="styles.css">
    <title>
    SAT Solver
    </title>
  </head>
  <body>
    <ul>
      <li class="menu"><a href="index.html">Úvod</a></li>
      <li class="menu"><a href="solver.html">SAT Solver</a></li>
      <li class="submenu">
        <a class="submenu-button">Konkrétní problémy</a>
        <div class="submenu-elements">
          <a href="pozorovani.html">Pozorování</a>
          <a href="sudoku.html">Sudoku</a>
          <a href="abc.html">Easy as ABC</a>
          <a href="logik.html">Logik</a>
          <a href="slitherlink.html">Slitherlink</a>
        </div>
      </li>
      <li class="menu"><a href="dokumentace.html">Technická dokumentace</a></li>
      <li class="menu"><a href="zaver.html">Závěr</a></li>
      <li class="menu"><a href="citace.html">Citace</a></li>
    </ul>
    <article>
      <h2 id="title">SAT Solver</h2>
      <section>
        <h3>SAT</h3>
        <p>Algoritmus, který zde budu popisovat, pracuje s úlohami SAT. SAT úlohy zadávají booleovskou formuli tvořenou proměnnými, a ptají se na otázku, zda lze těmto proměnným přiřadit hodnotu 0 nebo 1 tak, aby byla výsledná formule vyhodnocená jako pravdivá - tedy zda je formule SATISFIABLE.</p>
      </section>
      <section>
        <h3>CNF</h3>
        <p>Protože hledat řešení obecné logické formule je příliš komplikované, pomůžeme si převedením formule do tzv. Conjunctive Normal Form. To je taková forma, kdy je formule zapsána jako konjunkce disjunkcí. Jednolivé disjunkce pak budu nazývat klausulemi. Příklad CNF formy může vypadat takto:</p>
        <p class="formula">(A ∨ B ∨ C) ∧ (D ∨ E) ∧ (F ∨ G)</p>
        <p>Na to, aby platila celá formule, musí platit alespoň jedna proměnná v každé klausuli.</p>
      </section>
      <section>
        <h3>SAT Solver</h3>
        <p>Samotný algoritmus SAT Solveru je jednoduchá rekurzivní funkce, která se postupně snaží každé proměnné přiřadit jednu z hodnot {0, 1}. Je to tedy jakýsi DFS prohledávací algoritmus binárního stromu, kde listy reprezentují všechna možná přiřazení proměnných. Pro efektivitu takového algoritmu je ale potřeba použít metodu ořezávání. </p>
        <p>Proto je vhodné vytvořit funkci, která po každém přiřazení zkontroluje, zda je problém ještě možné splnit. Ve chvíli, kdy z jakékoliv klausule budou mít všechny proměnné opačnou hodnotu, než klausule vyžaduje, daný problém už je nesplnitelný - nemusíme pokračovat až k listům, abychom se o tomto výsledku přesvědčili. Jednoduše by se tedy kontrolovací funkce dala napsat tak, aby pro každou klausuli zjistila, jestli už jsou přiřazeny všechny její proměnné. Pro tyto klausule by pak zkontrolovala, že alespoň jedna z proměnných má hodnotu, kterou klausule vyžaduje.</p>
        <p>Protože však bude tato funkce volána při každém přiřazení proměnné, je nutné ji zefektivnit, aby nezpomalovala celý algoritmus. Proto je implementována tak, že pro každou klausuli na začátku určí libovolnou proměnnou, která se v ní vyskytuje. Na tuto proměnnou bude klausule "navěšena". Po každém přiřazení pak stačí zkontrolovat, zda existujou nějaké klausule "navěšené" na tuto proměnnou, které vyžadují opačnou hodnotu. Tyto klausule pak funkce zkusí "navěsit" na jinou proměnnou. To je možné tehdy, kdy je daná proměnná buď ještě nepřiřazená, nebo má hodnotu, která klausuli vyhovuje. </p>
        <p>Pokud se stane, že nějakou klausuli není možné takto "navěsit", pak jsme narazili na formuli, která je pro dané přiřazení nesplnitelná, a můžeme oříznout celý podstrom, v jehož kořenu právě jsme. To uděláme vynořením se z rekurze o 1.</p>
      </section>
    </article>
  </body>
</html>
